<template>
  <div
    class="profile_resources card"
    :class="{ disabled: disableCard }">
    <div class="profile_resources-header">
      <div class="profile_resources-header-title">
        {{ $t("profile.addResources") }}
      </div>
    </div>
    <div class="profile_resources-body">
      <div class="flex flex-center pb-15">
        <AmountInput
          @change="
            (val) => {
              settings[active].amount = parseFloat(
                (settings[active].amount + val).toFixed(2)
              );
            }
          "
          @input="
            (val) => {
              settings[active].amount = parseFloat(val.toFixed(2));
            }
          "
          :disabledInput="false"
          :value="amount"
          :label="$t('profile.resourceSlider.' + active)"
          :step="settings[active].step"
        ></AmountInput>
      </div>
      <div class="flex flex-center myBets_body-slider">
        <div class="flex flex-middle">
          <div
            class="progress"
            :style="{ backgroundColor: settings[active].color }"
          ></div>
        </div>
        <BSlider
          :backgroundColor="settings[active].color"
          :showValues="false"
          :zeroBlock="settings[active].min"
          :min="settings[active].min"
          :max="settings[active].max"
          :step="settings[active].step"
          v-model="settings[active].amount"
        ></BSlider>
      </div>
      <div
        class="profile_resources_btn-container flex flex-between flex-middle"
      >
        <div
          class="profile_resources_btn profile_resources_btn-ram"
          :class="{ active: active === 'ram' }"
          @click="setActive('ram')"
        >
          <div
            class="profile_resources_btn-header flex flex-center flex-middle"
          >
            {{ $t("profile.reserve") }}
          </div>
          <div class="profile_resources_btn-body flex flex-center flex-middle">
            {{ $t("profile.ram") }}
          </div>
        </div>
        <div
          class="profile_resources_btn profile_resources_btn-cpu"
          :class="{ active: active === 'cpu' }"
          @click="setActive('cpu')"
        >
          <div
            class="profile_resources_btn-header flex flex-center flex-middle"
          >
            {{ $t("profile.rent") }}
          </div>
          <div class="profile_resources_btn-body flex flex-center flex-middle">
            {{ $t("profile.cpu") }}
          </div>
        </div>
        <div
          class="profile_resources_btn profile_resources_btn-net"
          :class="{ active: active === 'net' }"
          @click="setActive('net')"
        >
          <div
            class="profile_resources_btn-header flex flex-center flex-middle"
          >
            {{ $t("profile.rent") }}
          </div>
          <div class="profile_resources_btn-body flex flex-center flex-middle">
            {{ $t("profile.net") }}
          </div>
        </div>
      </div>
      <div class="profile_resources-calculate">
        <div class="flex">
          <span
          >{{
              active === "ram"
                ? $t("profile.stackedAmount")
                : $t("profile.rentedAmount")
            }}:</span
          >
          <div
            class="text-bold flex"
            :style="{ color: settings[active].color }"
          >
            <span
              class="text-ellipsis"
              style="max-width: 250px; display: block; padding: 0px 5px"
            >{{ rentedAmount }}</span>
            EOS
          </div>
        </div>
        <div>
          <span>{{ $t("profile.period") }}:</span>
          <span class="text-bold color-white">{{
            active === "ram"
              ? $t("profile.nolimit")
              : "1 " + $t("profile.day")
          }}</span>
        </div>
      </div>
    </div>
    <div class="flex flex-center">
      <span
        class="color-white text-huge pt-20 pb-20 flex"
      ><span
        class="text-ellipsis"
        style="max-width: 250px; display: block">{{
          paymentAmount
        }}</span>
        EOS</span
      >
    </div>
    <div class="profile_resources-slider-btn flex flex-center">
      <Btn
        :loading="loading"
        @click="submit">{{ $t("profile.accept") }}
      </Btn>
    </div>
  </div>
</template>

<script>
  import Btn from "~/components/UI/BtnSign";
  import AmountInput from "~/components/UI/AmountInput";
  import Timer from "~/components/UI/Timer";
  import Progress from "~/components/UI/Progress";
  import BSlider from "~/components/UI/Slider";
  import notification from "~/components/UI/Notification/main.js";
  import {flooring} from "~/components/utils";
  import resourceManager from '~/services/resourceManager';

  export default {
    name: "bonuses",
    data() {
      return {
        disabled: false,
        loading: false,
        max: 5,
        step: 0.1,
        rentedAmount: 0,
        paymentAmount: 0,
        currentFrac: 0,
        active: "ram",
        settings: {
          ram: {
            color: "#82e093",
            step: 1,
            max: 500,
            min: 1,
            multiplier: 1024,
            amount: 0,
          },
          cpu: {
            color: "#d3a451",
            step: 1,
            max: 1000,
            min: 1,
            multiplier: 1000,
            amount: 0,
          },
          net: {
            color: "#00bac3",
            step: 400,
            max: 5000,
            min: 400,
            multiplier: 1024,
            amount: 0,
          },
        },
        rexInfo: {},
      };
    },
    components: {
      Btn,
      AmountInput,
      Timer,
      Progress,
      BSlider,
    },
    computed: {
      disableCard() {
        return (
          (this.$store.state.common.demo ||
            this.$store.state.wallet.accountName === "No account")
        );
      },
      ramPrice() {
        return this.$store.state.wallet.price.ram;
      },
      resources() {
        return this.$store.state.wallet.calculatedResources;
      },
      amount() {
        return this.settings[this.active].amount;
      },
    },
    methods: {
      submit() {
        this["buy" + this.active]();
      },
      setActive(active) {
        this.active = active;
        switch (active) {
          case "ram": {
            break;
          }
          case "cpu": {
            break;
          }
          case "net": {
            /*const step = (0.0001 * 1) / (this[active + "Price"] * this.settings[active].multiplier);
            this.settings[active].min = Math.round(step);
            this.settings[active].step = Math.round(step);*/
            break;
          }
          default: {
            break;
          }
        }

        this.calculatePrice();
      },
      calculatePrice() {
        switch (this.active) {
          case "ram": {
            const rentedAmount =
              Math.round(
                this[this.active + "Price"] *
                this.amount *
                this.settings[this.active].multiplier *
                10000
              ) / 10000;
            this.rentedAmount = rentedAmount;
            this.paymentAmount = rentedAmount;
            break;
          }
          case "cpu": {
            const {recievedAmount, price, frac} = resourceManager.calcCpu(this.amount);
            this.rentedAmount = flooring(Math.round(recievedAmount / 10000));
            this.paymentAmount = flooring(price * 1.5);
            this.currentFrac = frac;
            break;
          }
          case "net": {
            const {recievedAmount, price, frac} = resourceManager.calcNet(this.amount);
            this.rentedAmount = flooring(Math.round(recievedAmount / 10000));
            this.paymentAmount = flooring(price * 1.5);
            this.currentFrac = frac;
            break;
          }
          default: {
            break;
          }
        }
      },
      buyram(amount = this.amount) {
        if (!this.disableCard) {
          this.loading = true;
          this.$store
            .dispatch("user/stackRam", {
              amount: 1024 * amount,
            })
            .then((_) => {
              notification.success({
                message: this.$t("profile.notificationResult.ram"),
              });
              this.$store
                .dispatch("wallet/getAccount")
                .then((res) => {
                  this.loading = false;
                })
                .catch((e) => {
                  this.loading = false;
                });
            })
            .catch((e) => {
              console.log("stack error - ", e);
              notification.warning({
                message: e.message,
              });
              this.loading = false;
            });
        }
      },
      buycpu(amount = this.paymentAmount) {
        if (!this.disableCard) {
          if (Math.round(amount * 10000) === 0) {
            return notification.warning({
              message: "Stacked resource need to be more than 0.0001 EOS",
            });
          }
          this.loading = true;
          this.$store
            .dispatch("user/powerUp", {
              net_frac: 0,
              cpu_frac: this.currentFrac,
              max_payment: amount,
            })
            .then((_) => {
              notification.success({
                message: this.$t("profile.notificationResult.cpu"),
              });
              this.$store
                .dispatch("wallet/getAccount")
                .then(_ => {
                  this.loading = false;
                })
                .catch(_ => {
                  this.loading = false;
                });
            })
            .catch((e) => {
              console.log("stack error - ", e);
              notification.warning({
                message: e.message,
              });
              this.loading = false;
            });
        }
      },
      buynet(amount = this.paymentAmount) {
        if (!this.disableCard) {
          if (Math.round(amount * 10000) === 0) {
            return notification.warning({
              message: "Stacked resource need to be more than 0.0001 EOS",
            });
          }
          this.loading = true;
          this.$store
            .dispatch("user/powerUp", {
              net_frac: this.currentFrac,
              cpu_frac: 0,
              max_payment: amount,
            })
            .then((_) => {
              notification.success({
                message: this.$t("profile.notificationResult.net"),
              });
              this.$store
                .dispatch("wallet/getAccount")
                .then(_ => {
                  this.loading = false;
                })
                .catch(_ => {
                  this.loading = false;
                });
            })
            .catch((e) => {
              console.log("stack error - ", e);
              notification.warning({
                message: e.message,
              });
              this.loading = false;
            });
        }
      },
    },
    watch: {
      amount: {
        immediate: true,
        handler() {
          this.calculatePrice();
        },
      },
      ramPrice: function () {
        this.calculatePrice();
      },
    },
    async mounted() {
      this.$store.dispatch("wallet/getCalculatedResources");
      resourceManager.refreshCache();

      this.$store
        .dispatch("wallet/getRexInfo")
        .then((res) => {
          this.rexInfo = res;
        })
        .catch((e) => {
          console.log("get rex info error - ", e);
        });
    },
  };
</script>
